﻿local buttons = {
	MainMenuMicroButton,
	CharacterMicroButton,
	SpellbookMicroButton,
	TalentMicroButton,
	AchievementMicroButton,
	QuestLogMicroButton,
	GuildMicroButton,
	LFDMicroButton,
	CollectionsMicroButton,
	EJMicroButton,
	StoreMicroButton,
	MainMenuBarBackpackButton,
	CharacterBag0Slot,
	CharacterBag1Slot,
	CharacterBag2Slot,
	CharacterBag3Slot,
};

local MicroButtonsBorder = CreateFrame("Frame", "MicroButtonBorder");
local addon = CreateFrame("Frame", "HideMicroButtonAndBagsBar");
addon:RegisterEvent("PLAYER_ENTERING_WORLD");
local onload = false;
addon:SetScript("OnEvent", function(_, event)
	if event == "PLAYER_ENTERING_WORLD" and not onload then
		initialize();
		onload = true;
	end
end);

function currentFrame()
	return MainMenuBar;
end

function GetAnchor1()
	if HideMicroButtonAndBags["Positions"] == "Right" then
		return "BOTTOMLEFT";
	else
		return "BOTTOMRIGHT";
	end
end

function GetAnchor2()
	if HideMicroButtonAndBags["Positions"] == "Right" then
		return "BOTTOMRIGHT";
	else
		return "BOTTOMLEFT";
	end
end

function GetPX()
	if HideMicroButtonAndBags["Positions"] == "Right" then
		return 1;
	else
		return -1;
	end
end

function initialize()
	if HideMicroButtonAndBags == nil then
		HideMicroButtonAndBags = {};
		HideMicroButtonAndBags["Hide"] = false;
		HideMicroButtonAndBags["Positions"] = "Right";
	else
		if HideMicroButtonAndBags["Hide"] == nil		then HideMicroButtonAndBags["Hide"] = false; end
		if HideMicroButtonAndBags["Positions"] == nil	then HideMicroButtonAndBags["Positions"] = "Right"; end
	end

	--HideMicroButtonAndBags["Positions"] = "Left";
	--HideMicroButtonAndBags["Positions"] = "Right";
	--HideMicroButtonAndBags["Hide"] = true;
	--HideMicroButtonAndBags["Hide"] = false;

	HideMBAG();
	posMBAG();
	addon:ClearAllPoints();
	addon:SetPoint(GetAnchor1(), currentFrame(), GetAnchor2(), 0, 0);
	addon:SetSize(MicroButtonAndBagsBar:GetSize());
	MicroButtonAndBagsBar:SetSize(40,48);
	MicroButtonAndBagsBar:ClearAllPoints();
	MicroButtonAndBagsBar:SetPoint(GetAnchor1(), currentFrame(), GetAnchor2(), 0, 0);

	MicroButtonAndBagsBar.MicroBagBar:Hide();

	MicroButtonsBorder:SetBackdrop({
		bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
        edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
        tile = true, tileSize = 16, edgeSize = 16, 
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	});
	MicroButtonsBorder:SetBackdropColor(0,0,0,1);
	MicroButtonsBorder:ClearAllPoints();
	MicroButtonsBorder:SetPoint(GetAnchor1(), MainMenuMicroButton, GetAnchor1(), -4*GetPX(), -4);
	MicroButtonsBorder:SetSize(276,44);
	MicroButtonsBorder:SetParent(MicroButtonAndBagsBar);
	MicroButtonsBorder:SetFrameLevel(3);
	
	local ob = MainMenuBarBackpackButton:CreateTexture();
	ob:SetAllPoints();
	ob:SetTexture("Interface/Buttons/ActionBarFlyoutButton");
	ob:SetTexCoord(0.01562500, 0.67187500, 0.39843750, 0.72656250);
	ob:SetSize(44,44);
	ob:ClearAllPoints();
	ob:SetPoint("CENTER");
	MainMenuBarBackpackButton.outBorder = ob;

	for id, button in pairs(buttons) do
		if id > 12 then
			local tex = button:CreateTexture();
			tex:SetAllPoints();
			tex:SetTexture("Interface/Buttons/UI-Quickslot2");
			tex:SetSize(56,56);
			tex:ClearAllPoints();
			tex:SetPoint("CENTER");
			button.outBorder = tex;
		end
	end

	if HideMicroButtonAndBags["Hide"] then
		MainMenuMicroButton:SetAlpha(0);
	end
	MainMenuMicroButton:HookScript("OnEnter", function(self)
		ShowMBAG();
	end);
	MainMenuMicroButton:RegisterForClicks("MiddleButtonUp");
	MainMenuMicroButton:HookScript("OnMouseUp", function(self, btn, down)
		if btn == "MiddleButton" then
			if MouseIsOver(MainMenuMicroButton) then
				HideMicroButtonAndBags["Hide"] = not HideMicroButtonAndBags["Hide"];
				if not HideMicroButtonAndBags["Hide"] then
					MainMenuMicroButton:SetAlpha(1);
				else
					HideMBAG();
				end
			elseif MouseIsOver(MainMenuBarArtFrame.LeftEndCap) then
				HideMicroButtonAndBags["Positions"] = "Left";
				posMBAG();
			elseif MouseIsOver(OverrideActionBarEndCapL) then
				HideMicroButtonAndBags["Positions"] = "Left";
				posMBAG();
			elseif MouseIsOver(MainMenuBarArtFrame.RightEndCap) then
				HideMicroButtonAndBags["Positions"] = "Right";
				posMBAG();
			elseif MouseIsOver(OverrideActionBarEndCapR) then
				HideMicroButtonAndBags["Positions"] = "Right";
				posMBAG();
			end
		end
	end);

	addon:SetScript("OnLeave", function(self)
		if not MouseIsOver(addon) then
			HideMBAG();
		end
	end);

	for id, button in pairs(buttons) do
		button:HookScript("OnLeave", function(self)
			if not MouseIsOver(addon) then
				HideMBAG();
			end
		end);
	end
end

function ShowMBAG()
	local prev;
	MicroButtonAndBagsBar:Show();
	MainMenuMicroButton:SetAlpha(1);
	for id, button in pairs(buttons) do
		button:Show();
		button:SetAlpha(1);
		if id > 1 and id < 12 then
			button:ClearAllPoints();
			button:SetPoint(GetAnchor1(), prev, GetAnchor2(), -4*GetPX(), 0);
		end
		prev = button;
	end
end

function HideMBAG()
	if HideMicroButtonAndBags["Hide"] then
		MainMenuMicroButton:SetAlpha(0);
	end
	for id, button in pairs(buttons) do
		MicroButtonAndBagsBar:Hide();
		if id > 1 and id < 12 then
			button:SetAlpha(0);
			button:Hide();
		end
	end
end

function posMBAG()
	addon:ClearAllPoints();addon:SetPoint(GetAnchor1(), currentFrame(), GetAnchor2(), 0, 0);
	MicroButtonAndBagsBar:ClearAllPoints();MicroButtonAndBagsBar:SetPoint(GetAnchor1(), currentFrame(), GetAnchor2(), 0, 0);
	MicroButtonsBorder:ClearAllPoints();MicroButtonsBorder:SetPoint(GetAnchor1(), MainMenuMicroButton, GetAnchor1(), -4*GetPX(), -4);
	MainMenuMicroButton:ClearAllPoints();MainMenuMicroButton:SetPoint(GetAnchor1(), MicroButtonAndBagsBar, GetAnchor2(), -35*GetPX(), 3);
	MainMenuBarBackpackButton:ClearAllPoints();MainMenuBarBackpackButton:SetPoint(GetAnchor1(), MicroButtonAndBagsBar, GetAnchor2(), -35*GetPX(), 43);
	CharacterBag0Slot:ClearAllPoints();CharacterBag0Slot:SetPoint(GetAnchor1(), MainMenuBarBackpackButton, GetAnchor2(), 4*GetPX(), 0);
	CharacterBag1Slot:ClearAllPoints();CharacterBag1Slot:SetPoint(GetAnchor1(), CharacterBag0Slot, GetAnchor2(), 4*GetPX(), 0);
	CharacterBag2Slot:ClearAllPoints();CharacterBag2Slot:SetPoint(GetAnchor1(), CharacterBag1Slot, GetAnchor2(), 4*GetPX(), 0);
	CharacterBag3Slot:ClearAllPoints();CharacterBag3Slot:SetPoint(GetAnchor1(), CharacterBag2Slot, GetAnchor2(), 4*GetPX(), 0);
end